<?php

namespace Drupal\mymodule\Authentication\Provider;

use Drupal\Core\Authentication\AuthenticationProviderInterface;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Session\AccountInterface;
use Symfony\Component\HttpFoundation\Request;
use Drupal\Core\Access;

/**
 * HTTP Basic authentication provider.
 */
class CustomAuth implements AuthenticationProviderInterface {

  /**
   * The entity type manager service.
   *
   * @var \Drupal\Core\Entity\EntityTypeManagerInterface
   */
  protected $entityTypeManager;

  /**
   * Constructs a HTTP basic authentication provider object.
   *
   * @param \Drupal\Core\Entity\EntityTypeManagerInterface $entity_type_manager
   *   The entity type manager service.
   */
  public function __construct(EntityTypeManagerInterface $entity_type_manager) {
    $this->entityTypeManager = $entity_type_manager;
  }

  /**
   * {@inheritdoc}
   */
  public function applies(Request $request) {
    $x_crsf = $request->headers->get('X-CSRF-Token');
    return !empty($x_crsf);
  }

  /**
   * {@inheritdoc}
   */
  public function authenticate(Request $request) {
    $x_crsf = $request->headers->get('X-CSRF-Token');
    $valid = \Drupal::csrfToken()->validate($x_crsf);

    $account = \Drupal\user\Entity\User::load(1);

    return $account;

    return NULL;
  }
}
